#ifndef KEYBOARD_CLASS
#define KEYBOARD_CLASS
#include "PCF8574.h"
#include <bits/stdc++.h> 
class Keyboard
{
private:
    unsigned long _timeElapsed;
    std::deque<char> _buffer;
    uint8_t _debounce;
    PCF8574* pcf8574;
    uint8_t _lastKey;
    uint8_t _current_scan_col;
    void scanColumn(uint8_t *key, uint8_t start, uint8_t stop);
    /* data */
public:
    Keyboard(uint8_t debounce);
    ~Keyboard();
    void scan();
    void scanAsync();
    void begin(TwoWire *databus);
    static char mapChr(uint8_t key);
    char getLastChr();
    bool available();
    void clear();
    String getString();
};
#endif